# Loader of the Alias Wafefront obj and mtl file formats

This C89 code base loads the Alias Wavefront
[`obj`](http://www.martinreddy.net/gfx/3d/OBJ.spec) and
[`mtl`](http://www.fileformat.info/format/material/) file formats. Note that
only a subset of these formats are currently supported.

For `obj` files, polygonal primitives with their per vertex position, normal
and texture coordinates are loaded. Smooth, common and material groupings are
also correctly handled.

For `mtl` files, the ambient, diffuse, specular, glossiness and transmissive RGB
or XYZ colors are supported. In addition, it loads the refraction index and the
illumination model. It also handles the ambient, diffuse, specular, glossiness and
bump textures as well as their attributes (blend< u|v \>, color correction,
channel mapping, texcoord < offset|scale|turbulence \>, image resolution and bump
multiplier).

## How to build

The library uses [CMake](http://www.cmake.org) and the
[RCMake](https://gitlab.com/vaplv/rcmake/#tab-readme) package to build. It also
depends on the [RSys](https://gitlab.com/vaplv/rsys/#tab-readme) library. First,
install the RCMake package and the RSys library. Then, generate the project
from the cmake/CMakeLists.txt file by appending the RCMake and RSys
install directories to the `CMAKE_PREFIX_PATH` variable. The resulting project
can be edited, built, tested and installed as any CMake project.

## Release notes

### Version 1.3

- Add the `aw_obj_purge` and `aw_mtl_purge` functions that not only reset the
state of the loaders, as the `aw_obj_clear` and `aw_mtl_clear` functions, but
also free their internal memory.

## License

AW is Copyright (C) 2013-2016 Vincent Forest (vaplv@free.fr). It is a free
software released under the [OSI](https://opensource.org)-approved LGPL v3+
license. You are welcome to redistribute it under certain conditions; refer to
the COPYING file for details.
